/* This program converts a CLooG input file into a OMEGA Calculator input rules.
 * July 15th 2003: first version.
 */

# include <stdio.h>
# include <cloog/cloog.h>

int main(int argv, char * argc[])
{ CloogProgram * program ;
  FILE * input, * output ;

  if (argv != 3)
  { fprintf(stderr,"[cloog2omega]ERROR: unexpected parameters.\n\n"
            "usage: cloog2omega input_file output_file\n"
            "stdin  is a special value for input_file  (standard input)\n"
            "stdout is a special value for output_file (standard output)\n") ;
    exit(1) ;
  }  
  
  /* stdin is a special value, when used, we set input to standard input. */
  if (strcmp(argc[1],"stdin") == 0)
  input = stdin ;
  else
  { input = fopen(argc[1],"r") ;
    if (input == NULL)
    { fprintf(stderr,"[cloog2omega]ERROR: %s file does not exist.\n",argc[1]);
      exit(1) ;
    }
  }
  
  /* stdout is a special value, when used, we set output to standard output. */
  if (strcmp(argc[2],"stdout") == 0)
  output = stdout ;
  else
  { output = fopen(argc[2],"w") ;
    if (output == NULL)
    { fprintf(stderr,"[cloog2omega]ERROR: can't create output file %s.\n",
              argc[2]) ;
      exit(1) ;
    }
  }

  program = cloog_program_read(input) ;
  fclose(input) ;

  cloog_program_dump_omega(output,program) ;
  fclose(output) ;
  
  return 0;
}
